<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfFuelReportItem_V4 ArrayType
 * @subpackage Arrays
 */
class ArrayOfFuelReportItem_V4 extends AbstractStructArrayBase
{
    /**
     * The FuelReportItem_V4
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\FuelReportItem_V4[]
     */
    public $FuelReportItem_V4;
    /**
     * Constructor method for ArrayOfFuelReportItem_V4
     * @uses ArrayOfFuelReportItem_V4::setFuelReportItem_V4()
     * @param \StructType\FuelReportItem_V4[] $fuelReportItem_V4
     */
    public function __construct(array $fuelReportItem_V4 = array())
    {
        $this
            ->setFuelReportItem_V4($fuelReportItem_V4);
    }
    /**
     * Get FuelReportItem_V4 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\FuelReportItem_V4[]|null
     */
    public function getFuelReportItem_V4()
    {
        return isset($this->FuelReportItem_V4) ? $this->FuelReportItem_V4 : null;
    }
    /**
     * This method is responsible for validating the values passed to the setFuelReportItem_V4 method
     * This method is willingly generated in order to preserve the one-line inline validation within the setFuelReportItem_V4 method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateFuelReportItem_V4ForArrayConstraintsFromSetFuelReportItem_V4(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfFuelReportItem_V4FuelReportItem_V4Item) {
            // validation for constraint: itemType
            if (!$arrayOfFuelReportItem_V4FuelReportItem_V4Item instanceof \StructType\FuelReportItem_V4) {
                $invalidValues[] = is_object($arrayOfFuelReportItem_V4FuelReportItem_V4Item) ? get_class($arrayOfFuelReportItem_V4FuelReportItem_V4Item) : sprintf('%s(%s)', gettype($arrayOfFuelReportItem_V4FuelReportItem_V4Item), var_export($arrayOfFuelReportItem_V4FuelReportItem_V4Item, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The FuelReportItem_V4 property can only contain items of type \StructType\FuelReportItem_V4, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set FuelReportItem_V4 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\FuelReportItem_V4[] $fuelReportItem_V4
     * @return \ArrayType\ArrayOfFuelReportItem_V4
     */
    public function setFuelReportItem_V4(array $fuelReportItem_V4 = array())
    {
        // validation for constraint: array
        if ('' !== ($fuelReportItem_V4ArrayErrorMessage = self::validateFuelReportItem_V4ForArrayConstraintsFromSetFuelReportItem_V4($fuelReportItem_V4))) {
            throw new \InvalidArgumentException($fuelReportItem_V4ArrayErrorMessage, __LINE__);
        }
        if (is_null($fuelReportItem_V4) || (is_array($fuelReportItem_V4) && empty($fuelReportItem_V4))) {
            unset($this->FuelReportItem_V4);
        } else {
            $this->FuelReportItem_V4 = $fuelReportItem_V4;
        }
        return $this;
    }
    /**
     * Add item to FuelReportItem_V4 value
     * @throws \InvalidArgumentException
     * @param \StructType\FuelReportItem_V4 $item
     * @return \ArrayType\ArrayOfFuelReportItem_V4
     */
    public function addToFuelReportItem_V4(\StructType\FuelReportItem_V4 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\FuelReportItem_V4) {
            throw new \InvalidArgumentException(sprintf('The FuelReportItem_V4 property can only contain items of type \StructType\FuelReportItem_V4, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->FuelReportItem_V4[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\FuelReportItem_V4|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\FuelReportItem_V4|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\FuelReportItem_V4|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\FuelReportItem_V4|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\FuelReportItem_V4|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string FuelReportItem_V4
     */
    public function getAttributeName()
    {
        return 'FuelReportItem_V4';
    }
}
